<template>
  <el-card
    shadow="hover"
    style="height: 100%; display: flex; flex-direction: column"
  >
    <div slot="header" class="clearfix">
      <el-button
        :disabled="isDownloadDataButtonDisabled"
        :loading="isDownloading"
        style="float: right"
        size="mini"
        icon="el-icon-download"
        @click="updateMediaPlansFromVIMB"
        >Загрузить данные из VIMB
      </el-button>
      <el-input
        placeholder="Поиск заказов"
        v-model="searchString"
        @clear="filteredMediaPlans"
        @input="filterMediaPlans"
        size="mini"
        style="width: 300px; float: right; margin-right: 15px"
        clearable
      />
      <el-button
        style="float: left; margin-right: 15px"
        size="mini"
        :disabled="isReportButtonDisabled"
        @click="outMediaPlan"
        :loading="isLoadingReport"
      >
        Отчет
      </el-button>
      <span>
        <el-checkbox-button
          label="S.Fix"
          style="float: left"
          v-model="isSuperFixButton"
          @change="filterMediaPlans"
          id="SFixButton"
        />
        <el-checkbox-button
          label="Fix"
          style="float: left"
          v-model="isFixButton"
          @change="filterMediaPlans"
          id="fixButton"
        />
      </span>
    </div>
    <el-table
      :data="filteredMediaPlans"
      row-key="id"
      :header-cell-style="{ 'text-align': 'center' }"
      :cell-style="{ 'text-align': 'center' }"
      @selection-change="checkboxSelected"
    >
      <el-table-column type="selection" width="55" />
      <el-table-column width="100" prop="id" label="ID" />
      <el-table-column
        prop="order.agreement.advertiser.name"
        label="Рекламодатель"
      />
      <el-table-column label="Заказ">
        <template slot-scope="scope">
          {{ scope.row.order.name }}
        </template>
      </el-table-column>
      <el-table-column prop="name" label="Медиаплан" />
      <el-table-column label="Месяц" width="180">
        <template slot-scope="scope">
          <i class="el-icon-date" />
          <span style="margin-left: 10px">{{
            getStringifyMediaPlanDate(scope.row.month)
          }}</span>
        </template>
      </el-table-column>
      <el-table-column label="Тип" width="120">
        <template slot-scope="scope">
          <el-tag :type="scope.row.order.isSuperFix ? 'primary' : 'success'">
            {{ scope.row.order.isSuperFix ? "Super Fix" : "Fix" }}
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="Размещено">
        <template slot-scope="scope">
          <ComponentInventoryPercent :mediaPlan="scope.row" />
        </template>
      </el-table-column>
      <!-- Действия -->
      <el-table-column align="right">
        <template slot-scope="scope">
          <el-button
            round
            size="mini"
            type="primary"
            icon="el-icon-edit"
            @click="goToMediaPlanParameters(scope.row)"
            >Параметры
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="Вкл. размещение">
        <template slot-scope="scope">
          <el-checkbox
            :id="`check-box-is-placement-active-${scope.row.id}`"
            v-if="scope.row.hasParameters"
            v-model="scope.row.isPlacementActive"
            @change="setIsPlacementActive(scope.row)"
          />
        </template>
      </el-table-column>
    </el-table>
  </el-card>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { SellingDirection } from "@/interfaces/SellingDirection";
import { Channel } from "@/interfaces/Channel";
import { Advertiser } from "@/interfaces/Advertiser";
import { AxiosInstance } from "@/modules/AxiosInstance";
import { InterfaceMediaPlan, MediaPlan } from "@/interfaces/MediaPlan";
import ComponentMixin from "@/components/common/ComponentMixin";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import ComponentInventoryPercent from "@/components/search-media-plan-view/ComponentInventoryPercent.vue";
import { IsPlacementActive } from "@/interfaces/IsPlacementActive";
import { AxiosResponse } from "axios";
import { Loading } from "element-ui";
import { ElLoadingComponent } from "element-ui/types/loading";

/**
 * Компонент отображения и выбора медиаплана для задания автоматического размещения.
 */
@Component({ components: { ComponentInventoryPercent } })
export default class MediaPlansCollectionComponent extends Mixins(
  ComponentMixin
) {
  /**
   * Текст поиска
   */
  private searchString: string | null = null;
  /**
   * Признак "кнопка Fix включена".
   */
  private isFixButton = true;

  /**
   * Признак "кнопка S.Fix включена".
   */
  private isSuperFixButton = true;

  // Признак после нажатия иконка загрузки "загрузки данных vimb "
  private isDownloading = false;

  /**
   * Признак "кнопка загрузки данныхс vimb недоступна"
   */
  private isDownloadDataButtonDisabled = true;

  /**
   * Состояние индикатора загрузки.
   */
  private isLoadingReport = false;

  /**
   * Признак "кнопка отчета недоступна"
   */
  private isReportButtonDisabled = true;

  /**
   * Выбранное направление продаж
   */
  private sellingDirection: null | SellingDirection = null;

  /**
   * Выбранные каналы.
   */
  private channels: null | Channel[] = null;

  /**
   * Выбранные рекламодатели.
   */
  private advertisers: null | Advertiser[] = null;

  /**
   * Выбранный период.
   */
  private period: null | Date[] = null;

  /**
   * Коллекция медиапланов.
   */
  private mediaPlans: MediaPlan[] = [];
  // Фильтрация коллекции по нажатию кнопок "Fix, SFix".
  private filteredMediaPlans: MediaPlan[] = [];
  // Скопированный список для "Отчет".
  private copyIdMediaPlans: MediaPlan[] = [];

  /**
   * Метод срабатывает после создания компонента.
   */
  protected created(): void {
    // Подписываемся на события
    this.subscribeAll([
      ["on-selected-channels", this.onChannelsChanged],
      ["on-selected-month-range", this.onPeriodChanged],
      ["on-selected-advertisers", this.onAdvertisersChanged],
      ["on-selected-selling-direction", this.onSellingDirectionChanged],
    ]);
  }

  /**
   * Метод срабатывает после изменения выбранного направления продаж.
   * @param {SellingDirection} sellingDirection выбранное направление продаж.
   */
  protected onSellingDirectionChanged(
    sellingDirection: null | SellingDirection
  ): void {
    // Сохраняем направление продаж
    this.sellingDirection = sellingDirection;
    // Если направление продаж не указано - завершаем выполнение метода
    if (!this.sellingDirection) {
      this.isDownloadDataButtonDisabled = true;
      return;
    }

    // Вызываем метод проверки параметров
    this.checkBeforeRequest();
  }

  private checkboxSelected(arrayMediaPlans: Array<MediaPlan>): void {
    this.isReportButtonDisabled =
      !arrayMediaPlans ||
      !Array.isArray(arrayMediaPlans) ||
      arrayMediaPlans.length == 0;
    this.copyIdMediaPlans = arrayMediaPlans;
  }

  /**
   * Метод получени есть ли параметры медиаплана.
   *
   */
  private asyncHasParameters(id: number): void {
    AxiosInstance.get("media-plan-search-view/get-parameters-mediaPlans", {
      params: { id: id },
    }).then((response) => {
      const mediaPlan = this.mediaPlans.find((mediaPlan) => mediaPlan.id == id);
      if (mediaPlan) {
        mediaPlan.hasParameters = response.data;
        // Если есть параметры появляется check-box
        if (response.data) {
          this.getIsPlacementActive(mediaPlan);
        }
      }
    });
  }

  /**
   * Метод сохранение запущена ли расстановка.
   *
   * @param mediaPlan медиаплан.
   */
  @AsyncRequestCatchException
  private async setIsPlacementActive(mediaPlan: MediaPlan): Promise<void> {
    // Реализация библиотеки загрузки в "check box" расстановка "вкл" или "выкл"
    let loading = Loading.service({
      target: `#check-box-is-placement-active-${mediaPlan.id}`,
      lock: true,
    });
    // Отправляем запрос в бэк
    await AxiosInstance.post(
      "/media-plan-parameters/set-is-placement-active",
      new IsPlacementActive(mediaPlan.id, mediaPlan.isPlacementActive)
    );
    // Метод проверки поставленного значение
    this.getIsPlacementActive(mediaPlan, loading);
  }

  /**
   * Метод запроса признака запущена ли расстановка.
   *
   * @param mediaPlan медиаплан.
   * @param loading признак загрузки.
   */
  private async getIsPlacementActive(
    mediaPlan: MediaPlan,
    loading: ElLoadingComponent | null = null
  ): Promise<void> {
    try {
      //Отпраква запроса.
      const response: AxiosResponse = await AxiosInstance.get(
        "media-plan-parameters/get-is-placement-active",
        { params: { id: mediaPlan.id } }
      );
      if (response.data) {
        // Конвертируем ответ.
        const responseIsPlacement = response.data as boolean;

        mediaPlan.isPlacementActive = responseIsPlacement;
      }
    } finally {
      // Прекращение признака загрузки
      setTimeout(() => loading?.close(), 500);
    }
  }

  /**
   * Метод получение отчета.
   */
  @AsyncRequestCatchException
  private async outMediaPlan(): Promise<void> {
    const months = [
      "январь",
      "февраль",
      "март",
      "апрель",
      "май",
      "июнь",
      "июль",
      "август",
      "сентябрь",
      "октябрь",
      "ноябрь",
      "декабрь",
    ];
    // Берем ID mediaPlans для отправки на бэк-энд.
    let idMediaPlansRequests = this.copyIdMediaPlans.map((mp) => {
      return { id: mp.id };
    });
    // Берем месяц mediaPlans для формирования название xlsx файла
    let mothsMediaPlans = this.copyIdMediaPlans
      .map((value) => months[value.month.getMonth()])
      // делаем месяцы уникальными
      .filter((thing, i, arr) => arr.findIndex((t) => t === thing) === i);
    // Состояние индикатора загрузки кнопки "Отчет"
    this.isLoadingReport = true;
    try {
      // Отправляем запрос
      const response = await AxiosInstance.post(
        "report/placement",
        idMediaPlansRequests,
        {
          responseType: "blob",
        }
      );
      let link = document.createElement("a");
      link.href = window.URL.createObjectURL(new Blob([response.data]));
      link.setAttribute("download", "affinity: " + mothsMediaPlans + ".xlsx");
      document.body.appendChild(link);
      link.click();
      link.remove();
    } finally {
      this.isLoadingReport = false;
    }
  }

  /**
   * Метод срабатывает после изменения выбранных каналов.
   * @param {null | Channel[]} channels коллекция выбранных каналов.
   */
  private onChannelsChanged(channels: null | Channel[]): void {
    // Сохраняем каналы
    this.channels = channels;
    // Если коллекция выбранных каналов пустая - завершаем выполнение метода
    if (!this.channels || this.channels.length === 0) {
      this.isDownloadDataButtonDisabled = true;
      return;
    }

    // Вызываем метод проверки параметров
    this.checkBeforeRequest();
  }

  /**
   * Метод срабатывает после изменения выбранных рекламодателей.
   * @param {null | Advertiser[]} advertisers коллекция выбранных рекламодателей.
   */
  private onAdvertisersChanged(advertisers: null | Advertiser[]): void {
    // Сохраняем рекламодателей
    this.advertisers = advertisers;
    // Если коллекция выбранных рекламодателей пустая - завершаем выполнение метода
    if (!this.advertisers || this.advertisers.length === 0) {
      this.isDownloadDataButtonDisabled = true;
      return;
    }

    // Вызываем метод проверки параметров
    this.checkBeforeRequest();
  }

  /**
   * Метод срабатывает после изменения выбранного периода.
   * @param {null | Array<Date>} period выбранный период.
   */
  private onPeriodChanged(period: null | Date[]): void {
    // Сохраняем период
    this.period = period;
    // Если период не указан - завершаем выполнение метода
    if (!this.period || this.period.length === 0) {
      this.isDownloadDataButtonDisabled = true;
      return;
    }

    // Вызываем метод проверки параметров
    this.checkBeforeRequest();
  }

  /**
   * Метод проверки указанных параметров перед отправкой запроса коллекции медиапланов.
   */
  private checkBeforeRequest(): void {
    // Если направление продаж не указано - завершаем выполнение метода
    if (!this.sellingDirection) return;
    // Если коллекция каналов пустая - завершаем выполнение метода
    if (!this.channels || this.channels.length === 0) return;
    // Если коллекция рекламодателей пустая - завершаем выполнение метода
    if (!this.advertisers || this.advertisers.length === 0) return;
    // Если период не указан - завершаем выполнение метода
    if (!this.period || this.period.length === 0) return;

    this.isDownloadDataButtonDisabled = false;
    // Вызываем метод запроса коллекции медиапланов
    this.getMediaPlans();
    // Вызываем метод запроса обновления данных медиапл
  }

  /**
   * Метод запроса коллекции медиапланов.
   */
  @AsyncRequestCatchException
  private async getMediaPlans(): Promise<void> {
    // Отправляем запрос
    const response = await AxiosInstance.post(
      "media-plan-search-view/get-media-plans",
      {
        sellingDirection: this.sellingDirection?.id,
        dateFrom: this.period?.[0],
        dateBefore: this.period?.[1],
        channels: this.channels?.map((channel) => channel.id),
        advertisers: this.advertisers?.map((advertiser) => advertiser.id),
      }
    );

    this.mediaPlans.length = 0;

    // Если данных нет - завершаем выполнение метода
    if (!response.data) return;

    this.mediaPlans = (response.data as Array<unknown>)
      .map(
        (mediaPlanObject) =>
          new MediaPlan(mediaPlanObject as InterfaceMediaPlan)
      )
      .sort((a, b) => {
        return a.order.name.localeCompare(b.order.name);
      });
    // Фильтрация отображения "Fix, SFix"
    this.filterMediaPlans();
  }

  /**
   * Метод запроса обновления данных медиапланов из VIMB.
   */
  @AsyncRequestCatchException
  private async updateMediaPlansFromVIMB(): Promise<void> {
    try {
      this.isDownloading = true;
      const response = await AxiosInstance.post(
        "media-plan-search-view/download-media-plans",
        {
          sellingDirection: this.sellingDirection?.id,
          dateFrom: this.period?.[0],
          dateBefore: this.period?.[1],
          channels: this.channels?.map((channel) => channel.id),
          advertisers: this.advertisers?.map((advertiser) => advertiser.id),
        }
      );
      this.mediaPlans.length = 0;

      // Если данных нет - завершаем выполнение метода
      if (!response.data) return;

      this.mediaPlans = (response.data as Array<unknown>).map(
        (mediaPlanObject) =>
          new MediaPlan(mediaPlanObject as InterfaceMediaPlan)
      );
      this.filterMediaPlans();
      // eslint-disable-next-line no-useless-catch
    } catch (exception) {
      // Оставляем здесь обёртку в try catch так как есть действие в finally
      throw exception;
    } finally {
      this.isDownloading = false;
    }
  }

  /**
   * Метод отображения отфильтрованных медиапланов по "Fix или SFix".
   */
  private filterMediaPlans(): void {
    this.mediaPlans.forEach((mediaPlan) => {
      this.asyncHasParameters(mediaPlan.id);
    });
    // Если кнопки "Fix" и "sFix" = false.
    if (!this.isFixButton && !this.isSuperFixButton) {
      this.filteredMediaPlans.length = 0;
      return;
    }
    // Иначе
    this.filteredMediaPlans = this.mediaPlans.filter((mediaPlan) => {
      const isStringIncludes =
        this.searchString == null
          ? true
          : this.searchString.length == 0
          ? true
          : mediaPlan.order.name.includes(this.searchString);
      const isFix = !mediaPlan.order.isSuperFix && this.isFixButton;
      const isSuperFix = mediaPlan.order.isSuperFix && this.isSuperFixButton;
      return isStringIncludes && (isFix || isSuperFix);
    });
  }

  public getStringifyMediaPlanDate(date: Date): string {
    const monthName = date.toLocaleString("default", {
      year: "numeric",
      month: "long",
    });
    return monthName.charAt(0).toUpperCase() + monthName.slice(1);
  }

  /**
   * Метод инициализации перехода в представление параметров медиаплана для автоматического размещения.
   * @param {MediaPlan} mediaPlan медиаплан, который был выбран.
   */
  private goToMediaPlanParameters(mediaPlan: MediaPlan): void {
    // Вызываем событие перехода в параметры выбранного медиаплана,
    // чтобы родительский компонент инициализировал переход с анимацией
    // this.notify("selected-media-plan-parameters", mediaPlan);
    window.open(
      this.$router.resolve({
        name: "ViewMediaPlanParameters",
        params: { id: mediaPlan.id.toString() },
      }).href,
      "_blank"
    );
  }
}
</script>

<style lang="scss">
// Стиль кнопки "Fix"
#fixButton {
  .el-checkbox-button__inner {
    border-radius: 0 4px 4px 0;
    width: 75px;
    font-size: 12px;
    padding: 7px 15px;
  }
  &.is-checked {
    .el-checkbox-button__inner {
      color: #67c23a;
      border-color: #e1f3d8;
      background-color: #f0f9eb !important;
    }
  }
}
// Стиль кнопки "S.Fix"
#SFixButton {
  .el-checkbox-button__inner {
    border-radius: 4px 0 0 4px;
    width: 75px;
    font-size: 12px;
    padding: 7px 15px;
  }
  &.is-checked {
    .el-checkbox-button__inner {
      color: #409eff;
      border-color: #b3d8ff;
      background-color: #ecf5ff !important;
    }
  }
}
// Анимация для таблицы
tr.el-table__row {
  transition: all 0.2s ease-in-out;
  &:hover {
    transform: scale(1.005);
  }
}

.el-table__body-wrapper {
  &::-webkit-scrollbar {
    width: 10px !important;
  }
  &::-webkit-scrollbar-track {
    background: rgba(211, 211, 211, 0.25) !important;
    border-radius: 10px !important;
  }
  &::-webkit-scrollbar-thumb {
    background: rgba(211, 211, 211, 0.75) !important;
    border-radius: 10px !important;
  }
}
</style>
